' ----------------------------------------------------------
' Script d'exportation automatique de certificats EFS vers
' des fichiers .PFX
'
' Syntaxe: 
'	EXPORTCERT.VBS
'
' JC BELLAMY  2004
' ----------------------------------------------------------
Const SW_HIDE=0
Const SW_SHOWNORMAL=1 

Const CAPICOM_CERT_INFO_SUBJECT_SIMPLE_NAME = 0
Const CAPICOM_CERT_INFO_ISSUER_SIMPLE_NAME  = 1
Const CAPICOM_CERT_INFO_SUBJECT_EMAIL_NAME  = 2
Const CAPICOM_CERT_INFO_ISSUER_EMAIL_NAME   = 3
Const CAPICOM_CERT_INFO_SUBJECT_UPN         = 4
Const CAPICOM_CERT_INFO_ISSUER_UPN          = 5
Const CAPICOM_CERT_INFO_SUBJECT_DNS_NAME    = 6
Const CAPICOM_CERT_INFO_ISSUER_DNS_NAME     = 7

Const CAPICOM_ENCODE_ANY    = &hffffffff 
Const CAPICOM_ENCODE_BASE64 = 0
Const CAPICOM_ENCODE_BINARY = 1

Const CAPICOM_CERTIFICATE_SAVE_AS_PFX = 0 
Const CAPICOM_CERTIFICATE_SAVE_AS_CER = 1

Const CAPICOM_CERTIFICATE_INCLUDE_CHAIN_EXCEPT_ROOT = 0 
Const CAPICOM_CERTIFICATE_INCLUDE_WHOLE_CHAIN       = 1 
Const CAPICOM_CERTIFICATE_INCLUDE_END_ENTITY_ONLY   = 2

Const CAPICOM_MEMORY_STORE                          = 0 
Const CAPICOM_LOCAL_MACHINE_STORE                   = 1 
Const CAPICOM_CURRENT_USER_STORE                    = 2 
Const CAPICOM_ACTIVE_DIRECTORY_USER_STORE           = 3 
Const CAPICOM_SMART_CARD_USER_STORE                 = 4

Const CAPICOM_STORE_OPEN_READ_ONLY                  = 0 
Const CAPICOM_STORE_OPEN_READ_WRITE                 = 1 
Const CAPICOM_STORE_OPEN_MAXIMUM_ALLOWED            = 2 
Const CAPICOM_STORE_OPEN_EXISTING_ONLY              = 128 
Const CAPICOM_STORE_OPEN_INCLUDE_ARCHIVED           = 256


Const CAPICOM_KEY_STORAGE_DEFAULT        = 0 
Const CAPICOM_KEY_STORAGE_EXPORTABLE     = 1 
Const CAPICOM_KEY_STORAGE_USER_PROTECTED = 2


Const CAPICOM_EKU_OTHER                  = 0 
Const CAPICOM_EKU_SERVER_AUTH            = 1 
Const CAPICOM_EKU_CLIENT_AUTH            = 2 
Const CAPICOM_EKU_CODE_SIGNING           = 3 
Const CAPICOM_EKU_EMAIL_PROTECTION       = 4 
Const CAPICOM_EKU_SMARTCARD_LOGON        = 5 
Const CAPICOM_EKU_ENCRYPTING_FILE_SYSTEM = 6

Const OID_KP_EFS       = "1.3.6.1.4.1.311.10.3.4"
Const OID_EFS_RECOVERY = "1.3.6.1.4.1.311.10.3.4.1"

Set shell   = WScript.CreateObject("WScript.Shell")
Set fso     = WScript.CreateObject("Scripting.FileSystemObject")
Set net     = Wscript.CreateObject("WScript.Network")
Set args    = Wscript.Arguments

Set StdIn   = WScript.StdIn
Set StdOut  = WScript.StdOut
user=net.UserName

nbargs=args.count

TestHost true

Wscript.echo "----------------------------------------------------------------------------"
Wscript.echo "Ce script sauvegarde automatiquement les certificats et clefs utiliss par"
Wscript.echo "le chiffrement (EFS) de fichiers sous Windows 2000 et au-del." & VBCRLF
Wscript.echo "Pour cela il gnre des fichiers d'change d'informations personnelles"
Wscript.echo "(extension .PFX)."
Wscript.echo "Ces fichiers sont  conserver en lieu sr car ils servent en cas de besoin " 
Wscript.echo "rinstaller les certificats et clefs prives ayant servi  chiffrer les donnes." & VBCRLF
Wscript.echo "Le nom de chaque fichier est compos de l'objet du certificat et de l'empreinte"
Wscript.echo "numrique en hexadcimal."
Wscript.echo " "
Wscript.echo "JC BELLAMY  2004"
Wscript.echo "----------------------------------------------------------------------------"
Wscript.echo " "

TestCOMExists "ScriptPW.Password","scriptpw.dll"
Set oPW = CreateObject("ScriptPW.Password")
Wscript.echo "Vous pouvez saisir ci-dessous un mot de passe qui sera demand lors de la "
Wscript.echo "rinstallation des certificats. Si vous ne voulez pas utiliser de mot passe,"
Wscript.echo "appuyez seulement sur la touche <Entre>"
Wscript.echo " "
StdOut.write "Votre mot de passe : " 
pswd1 = oPW.GetPassword
If pswd1<>"" Then
	StdOut.write VBCRLF & "Confirmez votre mot de passe : " 
	pswd2 = oPW.GetPassword
	If pswd1<>pswd2 Then
		Wscript.echo VBCRLF & "Erreur dans la saisie du mot de passe"
		wscript.quit
		End If
	End If
Wscript.echo VBCRLF

TestCOMExists "CAPICOM.Store.2","capicom.dll"
Set Store=wscript.CreateObject("CAPICOM.Store.2")
Store.Open
Set collcertif=Store.Certificates
N=0
For each certif in collcertif 
	SimpleName=certif.GetInfo(CAPICOM_CERT_INFO_SUBJECT_SIMPLE_NAME)	
'	On ne retient que les certificats EFS
	Set CollEKU=Certif.ExtendedKeyUsage.EKUS
	IsEFSCert=false
	For each EKU in CollEKU
		If EKU.OID=OID_KP_EFS Then
			IsEFSCert=true
			exit for
			End If	
		Next
	If IsEFSCert and certif.HasPrivateKey Then
		set PrivK=certif.PrivateKey
		If PrivK.IsExportable Then
			N=N+1
			FileName=GetPath() & SimpleName & "-" & Certif.Thumbprint & ".pfx"
			SaveAs=CAPICOM_CERTIFICATE_SAVE_AS_PFX	
			certif.Save FileName,pswd1,SaveAs,CAPICOM_CERTIFICATE_INCLUDE_WHOLE_CHAIN
			Wscript.echo " "
			wscript.echo "Le certificat EFS """ & SimpleName & """ mis par" & VBCRLF & """" & Certif.IssuerName & """"
			wscript.echo "a t enregistr dans le fichier :" & VBCRLF & FileName & VBCRLF 
			If not certif.IsValid Then
				wscript.echo "Le certificat va tre plac dans le magasin des autorits de certification" 
				wscript.echo "racines de confiance"
				Set StoreRoot=wscript.CreateObject("CAPICOM.Store.2")
				StoreRoot.Open CAPICOM_CURRENT_USER_STORE,"ROOT",CAPICOM_STORE_OPEN_READ_WRITE
				StoreRoot.Load FileName,pswd1,CAPICOM_KEY_STORAGE_EXPORTABLE			
				End if
			End if
		End If
	Next
Wscript.echo "----------------------------------------------------------------------------"
If N=0 Then
	msg="Aucun certificat de chiffrement n'a t trouv." & VBCRLF
	msg=msg & "Cela est du au fait que le compte " & user & VBCRLF
	msg=msg & "n'a jamais chiffr de fichiers ou dossiers"	
else
	If N=1 Then 
		msg1="le fichier" 
		msg2="vient d'tre cr."
	else 
		msg1="les " & N & " fichiers"
		msg2="viennent d'tre crs."
		end if			
	msg="Il est vivement recommand de recopier ou dplacer vers un autre support" & VBCRLF
	msg=msg & "(disquette, clef USB, montage rseau, ...) " & msg1 &" .PFX qui" & VBCRLF
	msg=msg & msg2 & VBCRLF
	If pswd1<>"" Then msg=msg & VBCRLF & "N'oubliez pas de noter en lieu sr le mot de passe que vous avez indiqu." 
	End If
MsgBox msg, vbOKOnly + vbExclamation,"Certificats EFS"
wscript.quit

'--------------------------------------------------------------------
Sub TestCOMExists(name,module)
' Vrification d'installation d'un objet COM
On error resume next
dummy = shell.RegRead("HKCR\" & name & "\")
if err.number<>0 then 
' contrle ActiveX non enregistr
	pathmodule=getpath()& module
	If not fso.fileExists(pathmodule) Then
		Mess = "Le contrle ActiveX " & name & " est requis." & VBCRLF
		Mess=Mess & "Il est contenu dans le fichier " & module & VBCRLF
		Mess=Mess & "Or ce fichier n'a pas t trouv." & VBCRLF	
		MsgBox Mess, vbExclamation
		wscript.quit
		End If
	err.clear
	shell.Run "regsvr32.exe /s " & quote & pathmodule & quote, SW_SHOWNORMAL,true
	dummy = shell.RegRead("HKCR\" & name & "\")
	if err.number<>0 then 
		Mess = "Le contrle ActiveX " & name & " n'a pas pu tre enregistr"
		MsgBox Mess, vbExclamation
		wscript.quit
		end if	
	end if
On error goto 0
End Sub
'--------------------------------------------------------------------
' Fonction de rcupration du rpertoire courant
Function GetPath()
Dim path
path = WScript.ScriptFullName
GetPath = Left(path, InStrRev(path, "\"))
End Function
'--------------------------------------------------------------------
'Sous-programme de test du moteur
'Vu les sorties gnres, c'est CSCRIPT (et non pas WSCRIPT)
'qui doit tre utilis de prfrence
Sub TestHost(force)
dim rep
strappli=lcase(Wscript.ScriptFullName)
strFullName =lcase(WScript.FullName)
i=InStr(1,strFullName,".exe",1)
j=InStrRev(strFullName,"\",i,1)
strCommand=Mid(strFullName,j+1,i-j-1)
if strCommand<>"cscript" then
	If force then 
		Init="Ce script doit tre lanc avec CSCRIPT"
	Else
		Init="Il est prfrable de lancer ce script avec CSCRIPT"
		End If
	rep=MsgBox(Init & VBCRLF & _
	"Cela peut tre rendu permanent avec la commande" & VBCRLF & _
	"cscript //H:CScript //S /Nologo" & VBCRLF & _
	"Voulez-vous que ce soit fait automatiquement?", _
	vbYesNo + vbQuestion,strappli)
	if rep=vbYes  then 
		nomcmd="setscript.bat"
		Set ficcmd = fso.CreateTextFile(nomcmd)
		ficcmd.writeline "@echo off"
		ficcmd.writeline "cscript //H:CScript //S /Nologo"
		ficcmd.writeline "pause"
		params=""
		For i = 0 To nbargs-1 
			params=params & " " & args(i)
			next
		ficcmd.writeline chr(34) & strappli & chr(34) & params
		ficcmd.writeline "pause"
		ficcmd.close
		shell.Run nomcmd, SW_SHOWNORMAL,true
		force=true
		end if
    If force then WScript.Quit
	end if
end sub
'--------------------------------------------------------------------
